uses Alg3, gl;
var
  Alg: TAlg3;
  Oracle: PABCOracle;
  TargetFunction: PThresholdFunction;
  A, B, C, K1, K2, K,KA,KB,KC: LongInt;
  MinTau, MaxTau, MedTau: Integer;
  RA, RB, RC: Integer;
  MedTauReal: Real;
begin
    Writeln(' k1, k2, RA, RB, RC');
    ReadLn(k1,k2,RA, RB, RC);

    if K1 < K2 then
      K := K2
    else
      K := K1;
    MedTau := 0;
    MaxTau := 0;
    MinTau := Round(8*ln(K)/ln(2));

    for A := 0 to RA  do
    for B := 0 to RB  do
    for C := 0 to RC  do

    begin

      writeln(A:5, B:5, C:5);

      New(Oracle, Init(A, B, C));
      New(TargetFunction, Init);
      Alg.Init(K1, K2, Oracle, TargetFunction, nil);
      Alg.Run;

        {Alg.TotalAppeals;}
        MedTau := MedTau + Alg.TargetAppeals;
        if Alg.TargetAppeals > MaxTau then
        begin
          MaxTau := Alg.TargetAppeals;
          writeln(' ४:', MaxTau);
          KA:=A;
          KB:=B;
          KC:=C;
        end;
        if Alg.TargetAppeals < MinTau then
          MinTau := Alg.TargetAppeals;

      Alg.Done;
      Dispose(TargetFunction, Done);
      Dispose(Oracle);

      { 横}
    end;

    MedTauReal := MedTau /(RA+1) /(RB+1) /(RC+1);

    Writeln('Min = ', MinTau);
    Writeln('Max = ', MaxTau);
    Writeln('A =', KA, ' B=',KB, '  C=', KC);
    Writeln('Med =', MedTauReal:6:2);

    Readln;

end.