uses Alg3, gl;

type
  PRandomOracle = ^TRandomOracle;
  TRandomOracle = object(TOracle)
    function Answer(Point: TPoint): Boolean; virtual;
  end;

function TRandomOracle.Answer(Point: TPoint): Boolean;
begin
  if Random(2) = 0 then Answer := False else Answer := True;
end;

var
  Alg: TAlg3;
  Oracle: PRandomOracle;
  TargetFunction: PThresholdFunction;
  K1, K2, N, I, K, KA, KB, KC: LongInt;
  MinTau, MaxTau, MedTau: Integer;

begin
  Writeln(' K1, K2, N');
  Readln(K1, K2, N);

  if K1 < K2 then
    K := K2
  else
    K := K1;
  MedTau := 0;
  MaxTau := 0;
  MinTau := Round(8*ln(K)/ln(2));



  for I := 1 to N do
  begin
    Writeln(I);
    New(Oracle, Init);
    New(TargetFunction, Init);
    Alg.Init(K1, K2, Oracle, TargetFunction, nil);
    Alg.Run;

        MedTau := MedTau + Alg.TargetAppeals;
        if Alg.TargetAppeals > MaxTau then
        begin
          MaxTau := Alg.TargetAppeals;
          writeln(' ४:', MaxTau);
          KA := TargetFunction^.A;
          KB := TargetFunction^.B;
          KC := TargetFunction^.C;
        end;
        if Alg.TargetAppeals < MinTau then
          MinTau := Alg.TargetAppeals;

    Alg.Done;
    Dispose(TargetFunction, Done);
    Dispose(Oracle);
  end;

    Writeln('Min = ', MinTau);
    Writeln('Max = ', MaxTau);
    Writeln('A =', KA, ' B=',KB, '  C=', KC);

    Readln;


end.