Program Squares;

uses GL, WinCrt, graph;

var Count: Integer;

procedure DoSquares(n: Integer; X0, Y0, w: Real);
var w1, h: Real;
begin
    Count := Count + 1;
    Color(Count mod 256);
    Box(X0, Y0, X0 + w, Y0 + w, True);

    w1 := w/2.8;
    h := (w - 2*w1)/3;
    if n > 1 then
    begin
        DoSquares(n - 1, X0 + h, Y0 + h, w1);
        DoSquares(n - 1, X0 + w - h - w1, Y0 + h, w1);
        DoSquares(n - 1, X0 + h, Y0 + w - h - w1, w1);
        DoSquares(n - 1, X0 + w - h - w1, Y0 + w - h - w1, w1);
    end
end;

begin
    GraphInit;
    Limits(0, 0, 1, 1, True, True);
    Title('Squares');
    Count := 0;
    DoSquares(4, 0, 0, 1);
    Color(White);
    TitleBottom('Press [Enter] or [q] to exit');
    Wait([char(13), 'q']);
    GraphDone;
end.


