const MaxM = 1000;

type Matrix = array[1..MaxM] of real


procedure LinearInequalitiesSystem(
            M: Integer; );
var
  IneFileName, ExtFileName, BasFileName, IncFileName, LogFileName: String;
  IneFile, ExtFile, BasFile, IncFile, LogFile: Text;
  Ine, Ext, Bas, Inc: PLongMatrix;
  M, N: Integer;
  det: LongInt;
  Modification: Byte;
  Code: Integer;
  Dir: DirStr;
  Name: NameStr;
  Exten: ExtStr;
begin


  Ine := New(PLongMatrix, Init(2, 2));
  Ext := New(PLongMatrix, Init(2, 2));
  Inc := New(PLongMatrix, Init(2, 2));
  Bas := New(PLongMatrix, Init(2, 2));
  Ine^.ReSize(M, N);
  Ine^.FromFile(IneFile);
  Close(IneFile);

  case Ostow(Ine, Ext, Inc, Bas, Modification) of {call Ostow}
    -2: Writeln(' 墠⠥ ');
    -3: Writeln(' 襭, ⫨筮  0');
    1, 2:
    begin
      Writeln('Done');

      Assign(LogFile, LogFileName);
      Rewrite(LogFile);
      Writeln(LogFile, 'm=', Ine^.GetM, '  n=', Ine^.GetN);
      Writeln(LogFile, 'k=', Ext^.GetM);
      Writeln(LogFile);
      if Bas^.GetM = 0 then
        Writeln(LogFile, '஦ ')
      else
      begin
        Writeln(LogFile, ' ஦. ࠢ:', BasFileName);
        Writeln(LogFile);
      end;
      Writeln(LogFile);
      Print3LongMatrix(LogFile, Ext, Ine, Inc);
      Close(LogFile);

      Assign(ExtFile, ExtFileName);
      Rewrite(ExtFile);
      Writeln(ExtFile, Ext^.GetM, ' ', Ext^.GetN);
      Ext^.ToFile(ExtFile);
      Close(ExtFile);

      Assign(BasFile, BasFileName);
      Rewrite(BasFile);
      Writeln(BasFile, Bas^.M, ' ', Bas^.N);
      Bas^.ToFile(BasFile);
      Close(BasFile);

      Assign(IncFile, IncFileName);
      Rewrite(IncFile);
      Writeln(IncFile, Inc^.M, ' ', Inc^.N);
      Inc^.ToFile(IncFile);
      Close(IncFile);
    end;
  end; { case Ostow }

  Dispose(Ine, Done);
  Dispose(Ext, Done);
  Dispose(Inc, Done);
  Dispose(Bas, Done);
end.
