uses Alg3, gl;
var
  Alg: TAlg3;
  Oracle: PABCOracle;
  TargetFunction: PThresholdFunction;
  A, B, C, K1, K2, K,KA,KB,KC,RA,RB,RC: LongInt;
  MinTau, MaxTau, MedTau: Integer;
  R, N, I: Integer;
  MedTauReal: Real;
begin
    Writeln(' k1, k2, RA, RB, RC, N');
    ReadLn(k1, k2, RA, RB, RC, N);

    if K1 < K2 then
      K := K2
    else
      K := K1;
    MedTau := 0;
    MaxTau := 0;
    MinTau := Round(8*ln(K)/ln(2));

    for i := 1 to N do
    begin

      writeln(i);

      A := Random(RA);
      B := Random(RB);
      C := Random(RC);
      New(Oracle, Init(A, B, C));
      New(TargetFunction, Init);
      Alg.Init(K1, K2, Oracle, TargetFunction, nil);
      Alg.Run;

        {Alg.TotalAppeals;}
        MedTau := MedTau + Alg.TargetAppeals;
        if Alg.TargetAppeals > MaxTau then
        begin
          MaxTau := Alg.TargetAppeals;
          writeln(' ४:', MaxTau);
          KA:=A;
          KB:=B;
          KC:=C;
        end;
        if Alg.TargetAppeals < MinTau then
          MinTau := Alg.TargetAppeals;

      Alg.Done;
      Dispose(TargetFunction, Done);
      Dispose(Oracle);

      { 横}
    end;

    MedTauReal := MedTau / N;

    Writeln('Min = ', MinTau);
    Writeln('Max = ', MaxTau);
    Writeln('A =', KA, ' B=',KB, '  C=', KC);
    Writeln('Med =', MedTauReal:6:2);

    Readln;

end.