uses Alg3, gl;

type
  PRandomOracle = ^TRandomOracle;
  TRandomOracle = object(TOracle)
    function Answer(Point: TPoint): Boolean; virtual;
  end;

function TRandomOracle.Answer(Point: TPoint): Boolean;
begin
  if Random(2) = 0 then Answer := False else Answer := True;
end;

var
  Alg: TGraphAlg;
  Oracle: PRandomOracle;
  TargetFunction: PThresholdFunction;
  K1, K2: LongInt;
begin
  Writeln(' K1  K2');
  Readln(K1, K2);

  while true do
  begin
    New(Oracle, Init);
    New(TargetFunction, Init);
    Alg.Init(K1, K2, Oracle, TargetFunction, nil);
    Alg.Run;
    Alg.Done;
    Dispose(TargetFunction, Done);
    Dispose(Oracle);
  end;
end.