uses Alg3, gl;
var
  Alg: TGraphAlg;
  Oracle: PABCOracle;
  TargetFunction: PThresholdFunction;
  InputFile, OutputFile: System.Text;
  A, B, C, K1, K2: LongInt;
begin
  Assign(InputFile, 'b2d.dat');
  Reset(InputFile);
  Assign(OutputFile, 'b2d_out.dat');
  Rewrite(OutputFile);
  while not EOF(InputFile) do
  begin
    Read(InputFile, K1);
    Read(InputFile, K2);
    Read(InputFile, A);
    Read(InputFile, B);
    Read(InputFile, C);
    New(Oracle, Init(A, B, C));
    New(TargetFunction, Init);
    Alg.Init(K1, K2, Oracle, TargetFunction, @OutputFile);
    Alg.Run;
    Alg.Done;
    Dispose(TargetFunction, Done);
    Dispose(Oracle);
  end;
end.