uses Alg3, gl;
var
  Alg: TGraphAlg;
  Oracle: PABCOracle;
  TargetFunction: PThresholdFunction;
  OutputFile: System.Text;
  A, B, C, K1, K2: LongInt;
begin
  Assign(OutputFile, 'alg3simp.log');
  Rewrite(OutputFile);
  while true do
  begin
    Writeln('K1, K2 = ?  (0, 0 for exit)');
    Readln(K1, K2);
    if (K1 = 0) and (K2 = 0) or (K1 > 100) or (K2 > 100) then
      break;
    if (K1 < 2) or (K2 < 2) or (K1 > 100) or (K2 > 100) then
    begin
      writeln('Invalid values');
      writeln('1 < K1, K2 < 101');
      break;
    end;
    Writeln('A, B, C = ?');
    Read(A, B, C);
    New(Oracle, Init(A, B, C));
    New(TargetFunction, Init);
    Alg.Init(K1, K2, Oracle, TargetFunction, @OutputFile);
    Alg.Run;
    { 㯭 TeachingSet0  TeachingSet1}
    Alg.Done;
    Dispose(TargetFunction, Done);
    Dispose(Oracle);
  end;
  Close(OutputFile);
end.