uses Alg3, gl;
var
  Alg: TGraphAlg;
  Oracle: TABCOracle;
  TargetFunction: PThresholdFunction;
  InputFile: System.Text;
  A, B, C, K1, K2: LongInt;
  Event: TEvent;
begin
  Assign(InputFile, 'b2d.dat');
  Reset(InputFile);
  while not EOF(InputFile) do
  begin
    Read(InputFile, K1);
    Read(InputFile, K2);
    Read(InputFile, A);
    Read(InputFile, B);
    Read(InputFile, C);
    Oracle.Init(A, B, C);
    Alg.Init(K1, K2, @Oracle);
    Alg.Run;
    Alg.Done(TargetFunction);
    TargetFunction^.Done;
  end;
end.