Unit GCD;
Interface
Uses Strcts;
  function lGCD(U, V: LongInt): LongInt;
  function vGCD(P: PLongArray; n: Integer): LongInt;

Implementation
function lGCD(U, V: LongInt): LongInt;
var r: LongInt;
begin
  U := abs(U);
  V := abs(V);
  while V <> 0 do
  begin
    r := U mod V;
    U := V;
    V := r;
  end;
  lGCD := U;
end;

function vGCD(P: PLongArray; n: Integer): LongInt;
var
  j: Integer;
  d: LongInt;
begin
  d := Abs(P^[n]);
  j := n-1;
  while (d<>1) and (j>0) do
  begin
    d := lGCD(P^[j], d);
    Dec(j);
  end;
  vGCD := d;
end;

end.